package sati

type AnyTask interface {
	serialize() task
}

type task struct {
	Type string `json:"type"`
	Data any    `json:"data"`
}

type TurnstileTask struct {
	SiteKey string  `json:"siteKey"`
	PageUrl string  `json:"pageUrl"`
	CData   *string `json:"cData,omitempty"`
	Action  *string `json:"action,omitempty"`
}

func (t *TurnstileTask) serialize() task {
	return task{
		Type: "Turnstile",
		Data: t,
	}
}

type TurnstileResult struct {
	Token string `json:"token"`
}

type ReCaptcha2Task struct {
	SiteKey string `json:"siteKey"`
	PageUrl string `json:"pageUrl"`
}

func (t *ReCaptcha2Task) serialize() task {
	return task{
		Type: "ReCaptcha2",
		Data: t,
	}
}

type ReCaptcha2Result struct {
	Token string `json:"token"`
}
